Subject: #1586: Re: ISSUE: treatment of POSTED in proto articles

From: Harald Tveit Alvestrand <[email-masked]>
Date: Sun, 07 Dec 2008 11:01:41 +0100

I have recorded this as issue #1586.

Charles Lindsey skrev:
> Sory, I omitted to change the Subject line to include "ISSUE" the first
> time I posted this.
>
> In <[email-masked]> "Charles Lindsey" <[email-masked]> writes:
>
> In <[email-masked]> Russ Allbery <[email-masked]> writes:
>
>   
>> "Charles Lindsey" <[email-masked]> writes:
>>     
>
>   
>>> 3.4.1.  Proto-articles
>>>
>>>    A proto-article has the same format as a normal article except that
>>>    the Injection-Info and Xref header fields MUST NOT be present; the
>>>    Path header field MUST NOT contain a "POSTED" <diag-keyword>; and any
>>>    of the following mandatory header fields MAY be omitted: Message-ID,
>>>    Date, and Path.  In all other respects, a proto-article MUST be a
>>>    valid Netnews article.  In particular, the header fields which may be
>>>    omitted MUST NOT be present with invalid content.
>>>
>>> I am worried about that 'MUST NOT contain a "POSTED" <diag-keyword>'. It
>>> would cause no interoperability problems and cause no significant harm,
>>> and hence a "MUST" cannot be justified under RFC 2119. Nothing breaks if
>>> two "POSTEDs appear in one Path.  Indeed, it could arise legitimately in
>>> multiple injection "after the fact", and in other exotic gatewaying
>>> situations.
>>>
>>> Yes, some s[pc]ammers will preload the Path so as to disguise the true
>>> origin of an article (which is indeed why POSTED was invented), but that
>>> is a matter to be taken up by the netkops rather than the protocols. And
>>> I would prefer to preserve all evidence left over from previous Paths in
>>> order to facilitate bebugging of broken gateways, etc.
>>>
>>> So, at the most, it ought to be a SHOULD, and I would be happy to omit
>>> it altogether. Note that whatever change is made here, corresponding
>>> changes would be needed in 3.4.2 and 3.5.2 Step 2.
>>>       
>
>   
>> This is also a protocol change and should therefore be a separate issue.
>> I'm inclined to agree with you that MUST isn't justified here and SHOULD
>> is more appropriate.  I think we already talked about this before,
>> although I haven't gone back and looked.
>>     
>
> OK, here it is. I note that you agree that MUST is too strong.
>
> However, I think SHOULD (and perhaps even MAY) is too strong. The protocol
> use to prevent loops is not affected by this change. But the Path is also
> important for diagnosing the cause of loops (not necessarily
> non-terminating ones) such as those caused by peculiar gatewaying, and for
> spotting trollers who try to disguise the source of their articles.
>
> So seeing two 'POSTED's in a Path should immediately raise alarm bells
> (even though it may occasionally turn out to have a benign explanation).
> But if duplicate 'POSTED's are removed, then no alarm bells will be
> heard. So leave them in, and let the Debuggers and the Netkops take care
> of them.
>
> In either case, there would be consequential changes elsewhere, as noted.
>
>

---

From: "Charles Lindsey" <[email-masked]>
Date: Mon, 8 Dec 2008 17:17:18 GMT

>> OK, here it is. I note that you agree that MUST is too strong.

OK, I think at least s/MUST/SHOULD/ is necessary (no interoperability
implication), as Russ seems to agree.

So it is just a matter of whether to make it lower than SHOULD, on the
grounds given below. But, at this late stage I would settle for that
SHOULD if noone else speaks up. However, I really think it wrong to remove
evidence that might be helpful later, so I would encourage others to look
at this and comment here.

-- 
Charles H. Lindsey ---------At Home, doing my own thing------------------------
Tel: +44 161 436 6131 Fax: +44 161 436 6133   Web: http://www.cs.man.ac.uk/~chl
Email: [email-masked]      Snail: 5 Clerewood Ave, CHEADLE, SK8 3JU, U.K.
PGP: 2C15F1A9      Fingerprint: 73 6D C2 51 93 A0 01 E7 65 E8 64 7E 14 A4 AB A5